﻿package
{
	import flash.display.*;
	import flash.events.Event;
	
    public class OotW30Map
	extends MovieClip
    {
// *********************
// ***** CONSTANTS *****
// *********************
		public const O30:OotW30Constants = new OotW30Constants();
		public const MAP_STARTDATA:Array = new Array(
				0, 4, 0, 0, 0, 4, 4, 0,
				0, 0, 0, 4, 0, 0, 0, 0,
				4, 4, 0, 0, 0, 0, 4, 0, 
				0, 0, 0, 1, 0, 0, 0, 0, 
				4, 0, 0, 0, 0, 0, 4, 0,
				4, 0, 0, 2, 0, 0, 4, 0, 
				4, 0, 0, 3, 4, 0, 0, 0,
				4, 0, 0, 0, 4, 0, 4, 4 
				);
// *********************
// ***** VARIABLES *****
// *********************

		public var _currentMap:Array;
	
		public var _pushBox:OotW30Tileset;
		public var _pushX:uint;
		public var _pushY:uint;
		public var _pushD:uint;
		public var _pushFrame:uint;
		
// ***********************
// ***** CONSTRUCTOR *****
// ***********************

		public function OotW30Map()
		{
			var size:uint = O30.MAP_WIDTH * O30.MAP_HEIGHT;
			_currentMap = new Array(size);
			for (var cntr:uint = 0; cntr < size; ++cntr) {
				_currentMap[cntr] = new OotW30Tileset();
				_currentMap[cntr].setTileValue(MAP_STARTDATA[cntr]);
				_currentMap[cntr].x = Math.floor(cntr % 8) * O30.MAP_TILESIZE + O30.MAP_OFFSET_X;
				_currentMap[cntr].y = Math.floor(cntr / 8) * O30.MAP_TILESIZE + O30.MAP_OFFSET_Y;
				addChild(_currentMap[cntr]);
			}
			_pushBox = new OotW30Tileset();
			_pushBox.visible = false;
			addChild(_pushBox);
			stop();
		}

// *******************************************
// ***** Functions - Getting and Setting *****
// *******************************************

		public function getTile(nx:uint, ny:uint):uint
		{
			if ( (nx < 0) || (ny < 0) || (nx >= O30.MAP_WIDTH) || (ny >= O30.MAP_HEIGHT) )
				return 5;
			else
				return _currentMap[ny*O30.MAP_WIDTH + nx].getTileValue();
		}
		
		public function setTileValue(nx:uint, ny:uint, n:uint)
		{
			if ( (nx < 0) || (ny < 0) || (nx >= O30.MAP_WIDTH) || (ny >= O30.MAP_HEIGHT) )
				return;
			_currentMap[ny*O30.MAP_WIDTH + nx].setTileValue(n);
		}
		
		public function canEnter(nx:uint, ny:uint):Boolean
		{
			return (getTile(nx, ny) == 0);
		}
		
		public function canPush(nx:uint, ny:uint, nd:uint):Boolean
		{			
			var target:uint = getTile(nx, ny);
			if ((target < 1) || (target > 3)) { // make sure pushing a valid column of crates
				trace("not a movable column");
				return false;
			}
			var pushSpot:uint = getTile(nx + O30.DIR_OFFSETX[nd], ny + O30.DIR_OFFSETY[nd]);
			return (pushSpot == 0);
		}
		
		public function performPush(nx:uint, ny:uint, nd:uint)
		{
			if (canPush(nx, ny, nd)) {
				_pushBox.setTileValue(getTile(nx, ny));
				setTileValue(nx, ny, 0);
				_pushX = nx;
				_pushY = ny;
				_pushD = nd;
				_pushFrame = 0;
				addEventListener(Event.ENTER_FRAME, animateBox);
			}
/*			
			var tx:uint = nx;
			var ty:uint = ny;
			var ox:uint = nx + O30.DIR_OFFSETX[nd];
			var oy:uint = ny + O30.DIR_OFFSETY[nd];
			var boxSize:uint = getTile(nx, ny);
			while (canPush(tx, ty, nd))
			{
				_currentMap[ty*O30.MAP_WIDTH + tx].setTileValue(0);
				_currentMap[oy*O30.MAP_WIDTH + ox].setTileValue(boxSize);
				tx = ox;
				ox = tx + O30.DIR_OFFSETX[nd];
				ty = oy;
				oy = ty + O30.DIR_OFFSETY[nd];
			}
*/
		}
		
		public function resetMap()
		{
			var size:uint = O30.MAP_WIDTH * O30.MAP_HEIGHT;
			for (var cntr:uint = 0; cntr < size; ++cntr) {
				_currentMap[cntr].setTileValue(MAP_STARTDATA[cntr]);
			}
		}
		
		public function hasWon():Boolean
		{
			if ((getTile(0,3) == 3) && (getTile(1,3) == 2) && ((getTile(2,3) == 1) || (getTile(1,4) == 1)))
				return true;
			else
				return false;
		}
		
		protected function animateBox(evt:Event)
		{
			++_pushFrame;
			_pushBox.x = _pushX * O30.MAP_TILESIZE + O30.MAP_OFFSET_X + _pushFrame*8*O30.DIR_OFFSETX[_pushD];
			_pushBox.y = _pushY * O30.MAP_TILESIZE + O30.MAP_OFFSET_Y + _pushFrame*8*O30.DIR_OFFSETY[_pushD];
			_pushBox.visible = true;
			if (_pushFrame > 5) {
				_pushFrame = 0;
				_pushX += O30.DIR_OFFSETX[_pushD];
				_pushY += O30.DIR_OFFSETY[_pushD];
				if (getTile(_pushX + O30.DIR_OFFSETX[_pushD], _pushY + O30.DIR_OFFSETY[_pushD]) != 0) {
					removeEventListener(Event.ENTER_FRAME, animateBox);
					setTileValue(_pushX, _pushY, _pushBox.getTileValue());
					_pushBox.visible = false;
				}
			}
		}
	} // end class
} // end package