﻿package
{
	import flash.display.*;
	import flash.events.Event;
	
    public class OotW30Player
	extends MovieClip
    {
// *********************
// ***** CONSTANTS *****
// *********************
		public const O30:OotW30Constants = new OotW30Constants();
		public const MAP_START_X:uint = 0;
		public const MAP_START_Y:uint = 0;
		public const MAP_START_DIR:uint = O30.DIR_SOUTH;
		
// *********************
// ***** VARIABLES *****
// *********************

		public var _mapX:uint;
		public var _mapY:uint;
		public var _mapDir:Number;
		public var _targetX:uint;
		public var _targetY:uint;
		public var _targetD:Number;
		public var _frame:uint;
		public var _animating:Boolean;
		
// ***********************
// ***** CONSTRUCTOR *****
// ***********************

		public function OotW30Player()
		{
			setMapLocation(MAP_START_X, MAP_START_Y, MAP_START_DIR, false);
			stop();
		}

// *******************************************
// ***** Functions - Getting and Setting *****
// *******************************************
		public function setMapLocation(nx:uint, ny:uint, nd:uint = O30.DIR_NORTH, anim:Boolean = true)
		{
			// always set target just in case move animation is already active
			_targetX = nx;
			_targetY = ny;
			_targetD = nd;
			_frame = 0;
			_animating = anim;
			if (anim) {	
				addEventListener(Event.ENTER_FRAME, moveAnimation);
			} else {
				_mapX = nx;
				x = O30.MAP_OFFSET_X + nx*O30.MAP_TILESIZE + O30.MAP_HALFTILESIZE
				_mapY = ny;
				y = O30.MAP_OFFSET_Y + ny*O30.MAP_TILESIZE + O30.MAP_HALFTILESIZE
				_mapDir = nd;
				rotation = 0 + 90*nd;
			}
		}
		
		public function setDirection(nd:uint)
		{
			setMapLocation(_mapX, _mapY, nd);
//			_mapDir = nd;
//			rotation = 0 + 90*nd;
		}
		
		public function getMapX():uint
		{
			return _mapX;
		}
		
		public function getMapY():uint
		{
			return _mapY;
		}
		
		public function isAnimating():Boolean
		{
			return _animating;
		}
		
		protected function moveAnimation(evt:Event)
		{
			if  ((_targetX == _mapX) && (_targetY == _mapY) && (_targetD == _mapDir)) {
				removeEventListener(Event.ENTER_FRAME, moveAnimation);
				_animating = false;
			} else if (_targetD != _mapDir) {
				var dir = _targetD - _mapDir 
				if (dir > 1)
					dir = -1;
				if (dir < -1)
					dir = 1;
				rotation = 90 * _mapDir + 10 * _frame * dir;
				++_frame;
				if(_frame > 8) {
					_mapDir += dir;
					if (_mapDir < 0) 
						_mapDir = 3;
					if (_mapDir > 3)
						_mapDir = 0;
					rotation = 0 + 90*_mapDir;
					_frame = 0;
				}
			} else {
				++_frame;
				var xadj:Number = _targetX - _mapX;
				var yadj:Number = _targetY - _mapY;
				x = O30.MAP_OFFSET_X + _mapX*O30.MAP_TILESIZE + O30.MAP_HALFTILESIZE + xadj * _frame * 4;
				y = O30.MAP_OFFSET_Y + _mapY*O30.MAP_TILESIZE + O30.MAP_HALFTILESIZE + yadj * _frame * 4;
				if (_frame > 11) {
					_mapX = _targetX;
					_mapY = _targetY;
				}
			}
		}
		
	} // end class
} // end package